#ifndef __BASECONVERTH__
#define __BASECONVERTH__ 1

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <getopt.h>
#include <string.h>


enum input {single, user, integer};
enum input in_format = single;
/* operational mode for input */
enum mode {forward, reverse};
enum mode current_mode = forward;
/* Sign_mode only interesting for integer, doubles will always be signed */
enum sign {with_sign,no_sign};
enum sign sign_mode = no_sign; 

struct out_bits{
  char*  sign_bit;		// Bit for sign
  char* exponent;		// chars for exponet
  char* mant;			// chars for mantissa
};

/* Needed information for floating point conversions  */
struct F_format{
  unsigned sign_bit;		// 1 Bit
  unsigned exponent;		// bits for exponent
  unsigned mant;			// bits for mantissa
} ;


/* IEEE 754 single Precicion Float */
struct F_format s_prec = {1,8,23};

/* user specific format */
struct F_format user_prec={0,0,0};

/* format to us in the application */
struct F_format *format;

/* Special string to hold integer conversion */
char out_int[33];

/* Special string to read reverse input */
char in_string[80];

/*  convert interger to a characterarray of 0 and 1 */
/*  Arguments: in    -> number to convert			*/
/* 			out   -> chararray of [1,0]				*/
/* 		    width -> length of array				*/
void int2bin(int in ,char* out,int width);

/*  convert double to a characterarray of 0 and 1   */
/*  Arguments: in    -> number to convert			*/
/* 			out      -> chararray of [1,0]  		*/
/* 		    format   -> target format   			*/
void double2bin(double in,struct out_bits* out, struct F_format *format);

/*  convert  a characterarray of 0 and 1 to double  */
/*  Arguments: in    -> number to convert			*/
/* 			out      -> chararray of [1,0]  		*/
/* 		    format   -> target format   			*/
/* 	  returns: double  corresponding to bitstring   */   
double bin2double(char* in, struct F_format *format);

/*  converts characterarray of 0 and 1  to int      */
/*  Arguments: in    -> string to convert			*/
/* 			  		                                */
/* 	  returns: int corresponding to bitstring       */
int bin2int(char* in);

/*  prints a array of 0,1 to console grouped in packs of 4   */
/*  Arguments: in    -> number to convert			         */
void prettyprint_int(char* in,int width);

/*  prints a array of 0,1 to console grouped in packs of 4   */
/*  Arguments: in    -> struct of sign,exp,	mantissa         */
void prettyprint_struct(struct out_bits *in,struct F_format *format);

/* prints a quick helpreference to stdout */
void printhelp();


#endif
